**    ModelEco : MODELisation en programmation mathmatique pour l'analyse ECOnomique de l'agriculure    **

*-----------------------------------------------------------------------------*
$Ontext
Nom              Travail3.gms
Sequence         2 - Le modle d'exploitation agricole
Type             LP
Langage GAMS     Afficher statut du modle, desserrer toutes les contraintes
Description
"Soit une exploitation agricole qui peut pratiquer trois cultures, le bl, le mas et la tomate,
et deux itinraires techniques, extensif et intensif.
On cherche  dterminer la superficie  cultiver dans chaque culture et la technique  utiliser, sachant que :
Lobjectif de lagriculteur est la maximisation du revenu.

Les besoins en travail sont de :
                 Besoin en eau (m3)
Technique        extensif        intensif
Bl              0               2
Mais             4               6
Tomate           3               5

 Les besoins en travail sont de :
         Besoin en travail (h/ha)
         Technique         Priode
                      Hiver        Ete
Bl      extensif        10        5
         intensif        15        10
Mais     extensif        10        35
         Intensif        10        40
Tomate   extensif        10        70
         Intensif        10        90

Les rendements et les couts sont :
                 Rendement (tonne/ha)         Cout (/ha)
Technique        extensif        intensif        extensif        Intensif
Bl              4.5             5.0             250             300
Mais             8.0             10.0            400             500
Tomate           13.0            16.0            1200            1350

Le prix de vente est de 150/tonne pour le bl, 150/tonne pour le mas et 185/tonne pour la tomate.
La surface de lexploitation est de 50 ha, lagriculteur dispose de 2000 heures de travail par an
et dispose de 150 milliers de m3 pour lirrigation.
L'agriculteur a maintenant la possibilit d'embaucher des salaris  10 de l'heure,
d'acheter de l'eau  un prix de 50 par m3 et de louer la terre  150/ha. "


$Offtext


*----------                          INDICES                        ----------*
sets
C cultures       /ble,mais, tomate/
T techniques     /ext, int/
P priode        /hiver, ete/
;

*----------                          DONNEES                        ----------*
scalar
DTERRE disponibilite de terre en hectares        /50/
DEAU   disponibilite en eau                      /150/
PMO    prix horaire du travail salariee          /10/
PEau     prix de l'eau                           /50/
PTerre   prix de la terre                        /300/
;

parameter
DMO(P) disponibilit de travail en heures
/ete     1000
 hiver   1000/
;

table
BMO(C,T,P) besoins en travail par culture et technique (heures)
             hiver   ete
 ble.ext        10     5
 ble.int        15    10
 mais.ext       10    35
 mais.int       10    40
 tomate.ext     10    70
 tomate.int     10    90
;

table BEAU(C,T) besoins en eau par culture et technique (milliers mc)
             ext   int
 ble           0     2
 mais          4     6
 tomate        3     5
;

table
RDT (C, T) rendement par culture en tonne par hectar
        ext     int
ble     4.5     5.0
mais    8.0    10.0
tomate 13.0    16.0
;

parameter
PX (C) prix de vente par culture en euros
/ ble    150
  mais   150
  tomate 185/
;

table
COUT (C, T) cout variable par culture en euros par ha
        ext    int
ble     250    300
mais    400    500
tomate 1200   1350
;

parameter
MB(C, T) marge brute par culture en euros    ;
MB(C, T) = RDT(C, T)*PX(C)-COUT(C, T);

*----------                         MODELE                          ----------*
variables
Z    revenu total de l exploitation (euros)
;

positive variables
X     superficie par culture (hectares)
MOS(p) main d oeuvre salariee (heures)
EauA     eau achete
TerreA   terre achete
;

equations
   OBJECTIF       fonction objectif
   TERRE          contrainte de terre
   TRAVAIL(P)     contrainte de travail
   EAU            contrainte d'irrigation
;

OBJECTIF..       sum ((C,T), MB(C, T)* X(C, T)) - sum(P, MOS(P)*PMO) -EauA*PEau -PTerre*TerreA =E= Z ;

TERRE..          sum((C,T), X(C, T)) =l= dterre + TerreA ;

TRAVAIL(P)..     sum((C,T), BMO(C, T, P)*X(C, T)) =L= dmo(P) + MOS(P);

EAU..            sum((C,T), BEAU(C,T)*X(C,T)) =l= deau + EauA ;


model modelS2 premier exemple /all/;

*----------                        SOLUTION                         ----------*
solve modelS2 using LP maximizing Z;

parameter RESULT ;

RESULT(c,t) = X.L(c,t);
RESULT('Terre', 'Total') = TERRE.L;
RESULT('Terre', 'Marginal')=TERRE.M;
RESULT('Travail_Hiver', 'Total') = TRAVAIL.L('hiver');
RESULT('Travail_Hiver', 'Marginal')= TRAVAIL.M('hiver');
RESULT('Travail_Ete', 'Total') = TRAVAIL.L('ete');
RESULT('Travail_Ete', 'Marginal')= TRAVAIL.M('ete');
RESULT('MOS_Hiver', 'Total')= MOS.L('hiver');
RESULT('MOS_Ete', 'Total')= MOS.L('ete');
RESULT('Eau', 'Total') = EAU.L;
RESULT('Eau', 'Marginal')= EAU.M;
RESULT('EauA', 'Total') =EauA.L ;
RESULT(c,'TOTAL') = sum(t, X.L(c,t));
RESULT('StatutDuModele', 'Total')= modelS2.ModelStat ;
Display RESULT ;


execute_unload 'resultat_travail3_B.gdx' RESULT ;
execute 'gdxxrw.exe resultat_travail3_B.gdx par=RESULT'     ;